Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 2490)
+++ inc/admin/lib.moduleslist.php	(revision 2327)
@@ -1564,43 +1277,33 @@
 			if (!empty($actions)) {
 				$line .=
-				'<p>'.implode(' ', $this->getActions($id, $module, $actions)).'</p>';
-			}
+				'<form action="'.$this->getURL().'" method="post">'.
+				'<div>'.
+				$this->core->formNonce().
+				form::hidden(array('module'), html::escapeHTML($id)).
+
+				implode(' ', $this->getActions($id, $module, $actions)).
+ 
+				'</div>'.
+				'</form>';
+			}
+
+			$line .= 
+			'</div>';
 
 			$line .=
 			'</div>';
 
-			$line .=
-			'</div>';
-
 			$count++;
 
 			$res = $current ? $line.$res : $res.$line;
 		}
-
-		echo
+		echo 
 		$res.
 		'</div>';
 
 		if(!$count && $this->getSearch() === null) {
-			echo
-			'<p class="message">'.__('No themes matched your search.').'</p>';
-		}
-
-		elseif ((in_array('checkbox', $cols) || $count > 1) && !empty($actions) && $this->core->auth->isSuperAdmin()) {
-			$buttons = $this->getGlobalActions($actions, in_array('checkbox', $cols));
-
-			if (!empty($buttons)) {
-				if (in_array('checkbox', $cols)) {
-					echo 
-					'<p class="checkboxes-helpers"></p>';
-				}
-				echo '<div>'.implode(' ', $buttons).'</div>';
-			}
-		}
-
-		echo
-		'</form>';
-
-		return $this;
+			echo 
+			'<p class="message">'.__('No module matches your search.').'</p>';
+		}
 	}
 
@@ -1614,6 +1317,6 @@
 			# Select theme to use on curent blog
 			if (in_array('select', $actions) && $this->path_writable) {
-				$submits[] =
-				'<input type="submit" name="select['.html::escapeHTML($id).']" value="'.__('Use this one').'" />';
+				$submits[] = 
+				'<input type="submit" name="select" value="'.__('Use this one').'" />';
 			}
 		}
@@ -1625,53 +1328,14 @@
 	}
 
-	protected function getGlobalActions($actions, $with_selection=false)
-	{
-		$submits = array();
-
-		foreach($actions as $action) {
-			switch($action) {
-
-				# Update (from store)
-				case 'update': if ($this->core->auth->isSuperAdmin() && $this->path_writable) {
-					$submits[] =
-					'<input type="submit" name="update" value="'.($with_selection ?
-						__('Update selected themes') :
-						__('Update all themes from this list')
-					).'" />';
-				} break;
-
-				# Behavior
-				case 'behavior':
-
-					# --BEHAVIOR-- adminModulesListGetGlobalActions
-					$tmp = $this->core->callBehavior('adminModulesListGetGlobalActions', $this);
-
-					if (!empty($tmp)) {
-						$submits[] = $tmp;
-					}
-				break;
-			}
-		}
-
-		return $submits;
-	}
-
-	public function doActions()
-	{
-		if (empty($_POST) || !empty($_REQUEST['conf']) || !$this->isWritablePath()) {
-			return null;
-		}
-
-		$modules = !empty($_POST['modules']) && is_array($_POST['modules']) ? array_values($_POST['modules']) : array();
-
-		if (!empty($_POST['select'])) {
-
-			# Can select only one theme at a time!
-			if (is_array($_POST['select'])) {
-				$modules = array_keys($_POST['select']);
-				$id = $modules[0];
+	public function doActions($prefix)
+	{
+		if (!empty($_POST) && empty($_REQUEST['conf']) && $this->isWritablePath()) {
+
+			# Select theme to use on curent blog
+			if (!empty($_POST['module']) && !empty($_POST['select'])) {
+				$id = $_POST['module'];
 
 				if (!$this->modules->moduleExists($id)) {
-					throw new Exception(__('No such theme.'));
+					throw new Exception(__('No such module.'));
 				}
 
@@ -1680,269 +1344,10 @@
 				$this->core->blog->triggerBlog();
 
-				dcPage::addSuccessNotice(__('Theme has been successfully selected.'));
+				dcPage::addSuccessNotice(__('Module has been successfully selected.'));
 				http::redirect($this->getURL().'#themes');
 			}
 		}
 
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['activate'])) {
-
-			if (is_array($_POST['activate'])) {
-				$modules = array_keys($_POST['activate']);
-			}
-
-			$list = $this->modules->getDisabledModules();
-			if (empty($list)) {
-				throw new Exception(__('No such theme.'));
-			}
-
-			$count = 0;
-			foreach($list as $id => $module) {
-
-				if (!in_array($id, $modules)) {
-					continue;
-				}
-
-				# --BEHAVIOR-- themeBeforeActivate
-				$this->core->callBehavior('themeBeforeActivate', $id);
-
-				$this->modules->activateModule($id);
-
-				# --BEHAVIOR-- themeAfterActivate
-				$this->core->callBehavior('themeAfterActivate', $id);
-
-				$count++;
-			}
-
-			dcPage::addSuccessNotice(
-				__('Theme has been successfully activated.', 'Themes have been successuflly activated.', $count)
-			);
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['deactivate'])) {
-
-			if (is_array($_POST['deactivate'])) {
-				$modules = array_keys($_POST['deactivate']);
-			}
-
-			$list = $this->modules->getModules();
-			if (empty($list)) {
-				throw new Exception(__('No such theme.'));
-			}
-
-			$failed = false;
-			$count = 0;
-			foreach($list as $id => $module) {
-
-				if (!in_array($id, $modules)) {
-					continue;
-				}
-
-				if (!$module['root_writable']) {
-					$failed = true;
-					continue;
-				}
-
-				$module[$id] = $id;
-
-				# --BEHAVIOR-- themeBeforeDeactivate
-				$this->core->callBehavior('themeBeforeDeactivate', $module);
-
-				$this->modules->deactivateModule($id);
-
-				# --BEHAVIOR-- themeAfterDeactivate
-				$this->core->callBehavior('themeAfterDeactivate', $module);
-
-				$count++;
-			}
-
-			if ($failed) {
-				dcPage::addWarningNotice(__('Some themes have not been deactivated.'));
-			}
-			else {
-				dcPage::addSuccessNotice(
-					__('Theme has been successfully deactivated.', 'Themes have been successuflly deactivated.', $count)
-				);
-			}
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['delete'])) {
-
-			if (is_array($_POST['delete'])) {
-				$modules = array_keys($_POST['delete']);
-			}
-
-			$list = $this->modules->getDisabledModules();
-
-			$failed = false;
-			$count = 0;
-			foreach($modules as $id)
-			{
-				if (!isset($list[$id])) {
-
-					if (!$this->modules->moduleExists($id)) {
-						throw new Exception(__('No such theme.'));
-					}
-
-					$module = $this->modules->getModules($id);
-					$module['id'] = $id;
-
-					if (!$this->isDeletablePath($module['root'])) {
-						$failed = true;
-						continue;
-					}
-
-					# --BEHAVIOR-- themeBeforeDelete
-					$this->core->callBehavior('themeBeforeDelete', $module);
-
-					$this->modules->deleteModule($id);
-
-					# --BEHAVIOR-- themeAfterDelete
-					$this->core->callBehavior('themeAfterDelete', $module);
-				}
-				else {
-					$this->modules->deleteModule($id, true);
-				}
-
-				$count++;
-			}
-
-			if (!$count && $failed) {
-				throw new Exception(__("You don't have permissions to delete this theme."));
-			}
-			elseif ($failed) {
-				dcPage::addWarningNotice(__('Some themes have not been delete.'));
-			}
-			else {
-				dcPage::addSuccessNotice(
-					__('Theme has been successfully deleted.', 'Themes have been successuflly deleted.', $count)
-				);
-			}
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['install'])) {
-
-			if (is_array($_POST['install'])) {
-				$modules = array_keys($_POST['install']);
-			}
-
-			$list = $this->store->get();
-
-			if (empty($list)) {
-				throw new Exception(__('No such theme.'));
-			}
-
-			$count = 0;
-			foreach($list as $id => $module) {
-
-				if (!in_array($id, $modules)) {
-					continue;
-				}
-
-				$dest = $this->getPath().'/'.basename($module['file']);
-
-				# --BEHAVIOR-- themeBeforeAdd
-				$this->core->callBehavior('themeBeforeAdd', $module);
-
-				$this->store->process($module['file'], $dest);
-
-				# --BEHAVIOR-- themeAfterAdd
-				$this->core->callBehavior('themeAfterAdd', $module);
-
-				$count++;
-			}
-
-			dcPage::addSuccessNotice(
-				__('Theme has been successfully installed.', 'Themes have been successuflly installed.', $count)
-			);
-			http::redirect($this->getURL());
-		}
-
-		elseif ($this->core->auth->isSuperAdmin() && !empty($_POST['update'])) {
-
-			if (is_array($_POST['update'])) {
-				$modules = array_keys($_POST['update']);
-			}
-
-			$list = $this->store->get(true);
-			if (empty($list)) {
-				throw new Exception(__('No such theme.'));
-			}
-
-			$count = 0;
-			foreach($list as $module) {
-
-				if (!in_array($module['id'], $modules)) {
-					continue;
-				}
-
-				$dest = $module['root'].'/../'.basename($module['file']);
-
-				# --BEHAVIOR-- themeBeforeUpdate
-				$this->core->callBehavior('themeBeforeUpdate', $module);
-
-				$this->store->process($module['file'], $dest);
-
-				# --BEHAVIOR-- themeAfterUpdate
-				$this->core->callBehavior('themeAfterUpdate', $module);
-
-				$count++;
-			}
-
-			$tab = $count && $count == count($list) ? '#themes' : '#update';
-
-			dcPage::addSuccessNotice(
-				__('Theme has been successfully updated.', 'Themes have been successuflly updated.', $count)
-			);
-			http::redirect($this->getURL().$tab);
-		}
-
-		# Manual actions
-		elseif (!empty($_POST['upload_pkg']) && !empty($_FILES['pkg_file'])
-			|| !empty($_POST['fetch_pkg']) && !empty($_POST['pkg_url']))
-		{
-			if (empty($_POST['your_pwd']) || !$this->core->auth->checkPassword(crypt::hmac(DC_MASTER_KEY, $_POST['your_pwd']))) {
-				throw new Exception(__('Password verification failed'));
-			}
-
-			if (!empty($_POST['upload_pkg'])) {
-				files::uploadStatus($_FILES['pkg_file']);
-
-				$dest = $this->getPath().'/'.$_FILES['pkg_file']['name'];
-				if (!move_uploaded_file($_FILES['pkg_file']['tmp_name'], $dest)) {
-					throw new Exception(__('Unable to move uploaded file.'));
-				}
-			}
-			else {
-				$url = urldecode($_POST['pkg_url']);
-				$dest = $this->getPath().'/'.basename($url);
-				$this->store->download($url, $dest);
-			}
-
-			# --BEHAVIOR-- themeBeforeAdd
-			$this->core->callBehavior('themeBeforeAdd', null);
-
-			$ret_code = $this->store->install($dest);
-
-			# --BEHAVIOR-- themeAfterAdd
-			$this->core->callBehavior('themeAfterAdd', null);
-
-			dcPage::addSuccessNotice($ret_code == 2 ?
-				__('Theme has been successfully updated.') :
-				__('Theme has been successfully installed.')
-			);
-			http::redirect($this->getURL().'#themes');
-		}
-
-		else {
-
-			# --BEHAVIOR-- adminModulesListDoActions
-			$this->core->callBehavior('adminModulesListDoActions', $this, $modules, 'theme');
-
-		}
-
-		return null;
+		return parent::doActions($prefix);
 	}
 }
Index: inc/admin/lib.pager.php
===================================================================
--- inc/admin/lib.pager.php	(revision 2386)
+++ inc/admin/lib.pager.php	(revision 2323)
@@ -399,10 +399,5 @@
 			
 			if( $filter ) {
-				$html_block .= '<caption>'.
-					sprintf(__(
-						'Comment or trackback matching the filter.',
-						'List of %s comments or trackbacks matching the filter.',
-						$this->rs_count), $this->rs_count).
-					'</caption>';
+				$html_block .= '<caption>'.sprintf(__('List of %s Comments or trackbacks match the filter.'), $this->rs_count).'</caption>';
 			} else {
 				$html_block .= '<caption class="hidden">'.__('Comments and trackbacks list').'</caption>';
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 2492)
+++ inc/core/class.dc.core.php	(revision 2198)
@@ -87,5 +87,5 @@
 		$this->url = new dcUrlHandlers();
 		
-		$this->plugins = new dcPlugins($this);
+		$this->plugins = new dcModules($this);
 		
 		$this->rest = new dcRestServer($this);
Index: inc/core/class.dc.modules.php
===================================================================
--- inc/core/class.dc.modules.php	(revision 2492)
+++ inc/core/class.dc.modules.php	(revision 2245)
@@ -16,5 +16,6 @@
 @brief Modules handler
 
-Provides an object to handle modules (themes or plugins). 
+Provides an object to handle modules (themes or plugins). An instance of this
+class is provided by dcCore $plugins property and used for plugins.
 */
 class dcModules
@@ -35,5 +36,5 @@
 	protected static $_n;
 
-	protected static $type = null;
+	protected static $type = 'plugin';
 	
 	public $core;	///< <b>dcCore</b>	dcCore instance
@@ -160,11 +161,10 @@
 	@param	author		<b>string</b>		Module author name
 	@param	version		<b>string</b>		Module version
-	@param	properties	<b>array</b>		extra properties 
-	(currently available keys : permissions, priority, type)
+	@param	properties	<b>array</b>		extra properties (currently available keys : permissions, priority)
 	*/
 	public function registerModule($name,$desc,$author,$version, $properties = array())
 	{
-		# Fallback to legacy registerModule parameters
 		if (!is_array($properties)) {
+			//Fallback to legacy registerModule parameters
 			$args = func_get_args();
 			$properties = array();
@@ -176,6 +176,4 @@
 			}
 		}
-
-		# Default module properties
 		$properties = array_merge(
 			array(
@@ -187,6 +185,5 @@
 		);
 
-		# Check module type
-		if (self::$type !== null && $properties['type'] !== null && $properties['type'] != self::$type) {
+		if ($properties['type'] !== null && $properties['type'] != self::$type) {
 			$this->errors[] = sprintf(
 				__('Module "%s" has type "%s" that mismatch required module type "%s".'),
@@ -198,5 +195,4 @@
 		}
 
-		# Check module perms on admin side
 		$permissions = $properties['permissions'];
 		if ($this->ns == 'admin') {
@@ -208,5 +204,4 @@
 		}
 		
-		# Check module install on multiple path
 		if ($this->id) {
 			$module_exists = array_key_exists($name,$this->modules_names);
@@ -323,5 +318,5 @@
 				$id = $tmp[0];
 				$cur_module = $modules->getModules($id);
-				if (!empty($cur_module) && (defined('DC_DEV') && DC_DEV === true || dcUtils::versionsCompare($new_modules[$id]['version'], $cur_module['version'], '>', true)))
+				if (!empty($cur_module) && $new_modules[$id]['version'] != $cur_module['version'])
 				{
 					# delete old module
@@ -335,5 +330,5 @@
 					$zip->close();
 					unlink($zip_file);
-					throw new Exception(sprintf(__('Unable to upgrade "%s". (older or same version)'),basename($destination)));		
+					throw new Exception(sprintf(__('Unable to upgrade "%s". (same version)'),basename($destination)));		
 				}
 			}
Index: inc/core/class.dc.store.parser.php
===================================================================
--- inc/core/class.dc.store.parser.php	(revision 2388)
+++ inc/core/class.dc.store.parser.php	(revision 2222)
@@ -89,5 +89,5 @@
 			
 			# First filter right now. If DC_DEV is set all modules are parse
-			if (defined('DC_DEV') && DC_DEV === true || dcUtils::versionsCompare(DC_VERSION, $item['dc_min'], '>=', false)) {
+			if (defined('DC_DEV') && DC_DEV === true || version_compare(DC_VERSION,$item['dc_min'],'>=')) {
 				$this->items[$item['id']] = $item;
 			}
Index: inc/core/class.dc.store.php
===================================================================
--- inc/core/class.dc.store.php	(revision 2388)
+++ inc/core/class.dc.store.php	(revision 2270)
@@ -82,5 +82,5 @@
 		foreach ($current as $p_id => $p_infos) {
 			if (isset($raw_datas[$p_id])) {
-				if (dcUtils::versionsCompare($raw_datas[$p_id]['version'],$p_infos['version'],'>')) {
+				if (self::compare($raw_datas[$p_id]['version'],$p_infos['version'],'>')) {
 					$updates[$p_id] = $raw_datas[$p_id];
 					$updates[$p_id]['root'] = $p_infos['root'];
Index: inc/core/class.dc.themes.php
===================================================================
--- inc/core/class.dc.themes.php	(revision 2492)
+++ inc/core/class.dc.themes.php	(revision 2239)
@@ -41,11 +41,10 @@
 	@param	author		<b>string</b>		Module author name
 	@param	version		<b>string</b>		Module version
-	@param	properties	<b>array</b>		extra properties 
-	(currently available keys : parent, priority, standalone_config, type)
+	@param	properties	<b>array</b>		extra properties (currently available keys : parent, priority, standalone_config)
 	*/
 	public function registerModule($name,$desc,$author,$version,$properties = array())
 	{
-		# Fallback to legacy registerModule parameters
 		if (!is_array($properties)) {
+			//Fallback to legacy registerModule parameters
 			$args = func_get_args();
 			$properties = array();
@@ -57,12 +56,36 @@
 			}
 		}
-		# Themes specifics properties
 		$properties = array_merge(
-			array('parent' => null),
-			$properties,
-			array('permissions' => 'admin') // force themes perms
+			array(
+				'parent' => null,
+				'priority' => 1000,
+				'standalone_config' => false,
+				'type' => null
+			), $properties
 		);
 
-		parent::registerModule($name, $desc, $author, $version, $properties);
+		if ($properties['type'] !== null && $properties['type'] != self::$type) {
+			$this->errors[] = sprintf(
+				__('Module "%s" has type "%s" that mismatch required module type "%s".'),
+				'<strong>'.html::escapeHTML($name).'</strong>',
+				'<em>'.html::escapeHTML($properties['type']).'</em>',
+				'<em>'.html::escapeHTML(self::$type).'</em>'
+			);
+			return;
+		}
+
+		if ($this->id) {
+			$this->modules[$this->id] = array_merge(
+				$properties,
+				array(
+					'root' => $this->mroot,
+					'name' => $name,
+					'desc' => $desc,
+					'author' => $author,
+					'version' => $version,
+					'root_writable' => is_writable($this->mroot)
+				)
+			);
+		}
 	}	
 	
@@ -91,2 +114,3 @@
 	}
 }
+?>
Index: inc/core/class.dc.utils.php
===================================================================
--- inc/core/class.dc.utils.php	(revision 2388)
+++ inc/core/class.dc.utils.php	(revision 1179)
@@ -74,27 +74,4 @@
 		return $clean_ids;
 	}
-
-	/**
-	 * Compare two versions with option of using only main numbers.
-	 *
-	 * @param  string	$current_version	Current version
-	 * @param  string	$required_version	Required version
-	 * @param  string	$operator			Comparison operand
-	 * @param  boolean	$strict				Use full version
-	 * @return boolean	True if comparison success
-	 */
-	public static function versionsCompare($current_version, $required_version, $operator='>=', $strict=true)
-	{
-		if ($strict) {
-			$current_version = preg_replace('!-r(\d+)$!', '-p$1', $current_version);
-			$required_version = preg_replace('!-r(\d+)$!', '-p$1', $required_version);
-		}
-		else {
-			$current_version = preg_replace('/^([0-9\.]+)(.*?)$/', '$1', $current_version);
-			$required_version = preg_replace('/^([0-9\.]+)(.*?)$/', '$1', $required_version);
-		}
-
-		return (boolean) version_compare($current_version, $required_version, $operator);
-	}
 }
 
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 2492)
+++ inc/prepend.php	(revision 2341)
@@ -35,5 +35,4 @@
 $__autoload['dcPostMedia']				= dirname(__FILE__).'/core/class.dc.postmedia.php';
 $__autoload['dcModules']				= dirname(__FILE__).'/core/class.dc.modules.php';
-$__autoload['dcPlugins']				= dirname(__FILE__).'/core/class.dc.plugins.php';
 $__autoload['dcThemes']				= dirname(__FILE__).'/core/class.dc.themes.php';
 $__autoload['dcRestServer']			= dirname(__FILE__).'/core/class.dc.rest.php';
@@ -135,5 +134,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.6-RC');
+define('DC_VERSION','2.7-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
@@ -281,5 +280,5 @@
 	# 60 : template processing error
 	# 70 : blog is offline
-
+	
 	if (CLI_MODE)
 	{
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 2357)
+++ inc/public/class.dc.template.php	(revision 2198)
@@ -534,5 +534,5 @@
 	{
 		$f = $this->getFilters($attr);
-		return '<?php echo '.sprintf($f,'(!$_ctx->cur_loop ? 0 : $_ctx->cur_loop->index() + 1)').'; ?>';
+		return '<?php '.sprintf($f,'(!$_ctx->cur_loop ? 0 : $_ctx->cur_loop->index() + 1)').' ?>';
 	}
 	
Index: locales/en/resources.php
===================================================================
--- locales/en/resources.php	(revision 2367)
+++ locales/en/resources.php	(revision 1793)
@@ -22,3 +22,16 @@
 );
 
+$__resources['help'] = array(
+	'core_main' => dirname(__FILE__).'/help/main.html',
+	'core_blog_pref' => dirname(__FILE__).'/help/blog_pref.html',
+	'core_categories' => dirname(__FILE__).'/help/categories.html',
+	'core_comments' => dirname(__FILE__).'/help/comments.html',
+	'core_media' => dirname(__FILE__).'/help/media.html',
+	'core_post' => dirname(__FILE__).'/help/post.html',
+	'core_posts' => dirname(__FILE__).'/help/posts.html',
+	'core_trackbacks' => dirname(__FILE__).'/help/trackbacks.html',
+	'core_user_pref' => dirname(__FILE__).'/help/user_pref.html',
+	'core_user' => dirname(__FILE__).'/help/user.html',
+	'core_wiki' => dirname(__FILE__).'/help/wiki.html'
+);
 ?>
Index: plugins/antispam/index.php
===================================================================
--- plugins/antispam/index.php	(revision 2322)
+++ plugins/antispam/index.php	(revision 2495)
@@ -117,4 +117,5 @@
 	echo
 		dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+		dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 		dcPage::jsLoad('index.php?pf=antispam/antispam.js');
   }
Index: plugins/attachments/_admin.php
===================================================================
--- plugins/attachments/_admin.php	(revision 2360)
+++ plugins/attachments/_admin.php	(revision 1620)
@@ -12,28 +12,13 @@
 if (!defined('DC_CONTEXT_ADMIN')) { return; }
 
-$core->addBehavior('adminPostFormItems',array('attachmentAdmin','adminPostFormItems'));
-$core->addBehavior('adminPostAfterForm',array('attachmentAdmin','adminPostAfterForm'));
+$core->addBehavior ('adminPostFormItems',array('attachmentAdmin','adminPostFormItems'));
+$core->addBehavior ('adminPostAfterForm',array('attachmentAdmin','adminPostAfterForm'));
 $core->addBehavior('adminPostHeaders',array('attachmentAdmin','postHeaders'));
-$core->addBehavior('adminPageFormItems',array('attachmentAdmin','adminPostFormItems'));
-$core->addBehavior('adminPageAfterForm',array('attachmentAdmin','adminPostAfterForm'));
+$core->addBehavior ('adminPageFormItems',array('attachmentAdmin','adminPostFormItems'));
+$core->addBehavior ('adminPageAfterForm',array('attachmentAdmin','adminPostAfterForm'));
 $core->addBehavior('adminPageHeaders',array('attachmentAdmin','postHeaders'));
-$core->addBehavior('adminPageHelpBlock',array('attachmentAdmin','adminPageHelpBlock'));
 
 class attachmentAdmin
 {
-	public static function adminPageHelpBlock($blocks)
-	{
-		$found = false;
-		foreach($blocks as $block) {
-			if ($block == 'core_post') {
-				$found = true;
-				break;
-			}
-		}
-		if (!$found) {
-			return null;
-		}
-		$blocks[] = 'attachments';
-	}
 	public static function postHeaders()
 	{
@@ -69,5 +54,5 @@
 				'<li class="media-action"><a class="attachment-remove" id="attachment-'.$f->media_id.'" '.
 				'href="post_media.php?post_id='.$post->post_id.'&amp;media_id='.$f->media_id.'&amp;remove=1">'.
-				'<img src="images/trash.png" alt="'.__('remove').'" /></a>'.
+				'<img src="images/check-off.png" alt="'.__('remove').'" /></a>'.
 				'</li>'.
 				
Index: plugins/blogroll/index.php
===================================================================
--- plugins/blogroll/index.php	(revision 2256)
+++ plugins/blogroll/index.php	(revision 2495)
@@ -27,5 +27,5 @@
 {
 	$default_tab = 'import-links';
-	
+
 	try
 	{
@@ -35,5 +35,5 @@
 			throw new Exception(__('Unable to move uploaded file.'));
 		}
-		
+
 		require_once dirname(__FILE__).'/class.dc.importblogroll.php';
 		try {
@@ -44,6 +44,6 @@
 			throw $e;
 		}
-		
-		
+
+
 		if (empty($imported)) {
 			unset($imported);
@@ -69,12 +69,12 @@
 		}
 	}
-	
+
 	dcPage::addSuccessNotice(__('links have been successfully imported.'));
-	http::redirect($p_url);	
+	http::redirect($p_url);
 }
 
 if (!empty($_POST['cancel_import'])) {
 	$core->error->add(__('Import operation cancelled.'));
-	$default_tab = 'import-links';	
+	$default_tab = 'import-links';
 }
 
@@ -86,5 +86,5 @@
 	$link_desc = $_POST['link_desc'];
 	$link_lang = $_POST['link_lang'];
-	
+
 	try {
 		$blogroll->addLink($link_title,$link_href,$link_desc,$link_lang);
@@ -102,5 +102,5 @@
 {
 	$cat_title = $_POST['cat_title'];
-	
+
 	try {
 		$blogroll->addCategory($cat_title);
@@ -124,5 +124,5 @@
 		}
 	}
-	
+
 	if (!$core->error->flag()) {
 		dcPage::addSuccessNotice(__('Items have been successfully removed.'));
@@ -145,5 +145,5 @@
 	foreach ($order as $pos => $l) {
 		$pos = ((integer) $pos)+1;
-		
+
 		try {
 			$blogroll->updateOrder($l,$pos);
@@ -152,5 +152,5 @@
 		}
 	}
-	
+
 	if (!$core->error->flag()) {
 		dcPage::addSuccessNotice(__('Items order has been successfully updated'));
@@ -172,9 +172,10 @@
   <title><?php echo __('Blogroll'); ?></title>
   <?php echo dcPage::jsConfirmClose('links-form','add-link-form','add-category-form'); ?>
-  <?php 
+  <?php
 	$core->auth->user_prefs->addWorkspace('accessibility');
 	if (!$core->auth->user_prefs->accessibility->nodragdrop) {
 	echo
 		dcPage::jsLoad('js/jquery/jquery-ui.custom.js').
+		dcPage::jsLoad('js/jquery/jquery.ui.touch-punch.js').
 		dcPage::jsLoad('index.php?pf=blogroll/blogroll.js');
 	}
@@ -213,11 +214,11 @@
 {
 	$position = (string) $rs->index()+1;
-	
+
 	echo
 	'<tr class="line" id="l_'.$rs->link_id.'">'.
 	'<td class="handle minimal">'.form::field(array('order['.$rs->link_id.']'),2,5,$position,'position','',false,'title="'.__('position').'"').'</td>'.
 	'<td class="minimal">'.form::checkbox(array('remove[]'),$rs->link_id,'','','',false,'title="'.__('select this link').'"').'</td>';
-	
-	
+
+
 	if ($rs->is_cat)
 	{
@@ -235,5 +236,5 @@
 		'<td>'.html::escapeHTML($rs->link_lang).'</td>';
 	}
-	
+
 	echo '</tr>';
 }
@@ -245,5 +246,5 @@
 <p class="col">
 <?php
-	echo 
+	echo
 	form::hidden('links_order','').
 	form::hidden(array('p'),'blogroll').
@@ -252,5 +253,5 @@
 <input type="submit" name="saveorder" value="<?php echo __('Save order'); ?>" /></p>
 <p class="col right"><input type="submit" class="delete" name="removeaction"
-	 value="<?php echo __('Delete selected links'); ?>" 
+	 value="<?php echo __('Delete selected links'); ?>"
 	 onclick="return window.confirm('
 	 <?php echo html::escapeJS(__('Are you sure you want to delete selected links?')); ?>');" /></p>
@@ -330,5 +331,5 @@
 		'<th>'.__('Description').'</th>'.
 		'</tr>';
-		
+
 		$i = 0;
 		foreach ($imported as $entry) {
@@ -336,6 +337,6 @@
 			$title = html::escapeHTML($entry->title);
 			$desc  = html::escapeHTML($entry->desc);
-			
-			echo 
+
+			echo
 			'<tr><td>'.form::checkbox(array('entries[]'),$i,'','','').'</td>'.
 			'<td nowrap><a href="'.$url.'">'.$title.'</a>'.
@@ -345,5 +346,5 @@
 			'<td>'.$desc.
 			'<input type="hidden" name="desc['.$i.']" value="'.$desc.'" />'.
-			'</td></tr>'."\n";			
+			'</td></tr>'."\n";
 			$i++;
 		}
@@ -352,5 +353,5 @@
 		'<div class="two-cols">'.
 		'<p class="col checkboxes-helpers"></p>'.
-		
+
 		'<p class="col right">'.
 		form::hidden(array('p'),'blogroll').
Index: plugins/blowupConfig/_admin.php
===================================================================
--- plugins/blowupConfig/_admin.php	(revision 2351)
+++ plugins/blowupConfig/_admin.php	(revision 1179)
@@ -21,5 +21,5 @@
 {
 	if ($id == 'default' && $core->auth->check('admin',$core->blog->id)) {
-		return '<p><a href="plugin.php?p=blowupConfig" class="button submit">'.__('Configure theme').'</a></p>';
+		return '<p><a href="plugin.php?p=blowupConfig" class="button">'.__('Theme configuration').'</a></p>';
 	}
 }
Index: plugins/blowupConfig/index.php
===================================================================
--- plugins/blowupConfig/index.php	(revision 2442)
+++ plugins/blowupConfig/index.php	(revision 2335)
@@ -316,5 +316,5 @@
 
 	echo
-	'<h5 class="pretty-title">'.__('Top image').'</h5>'.
+	'<h5 class="pretty-title">'.__('Top image').'</h4>'.
 	'<p class="field"><label for="top_image">'.__('Top image').'</label> '.
 	form::combo('top_image',$top_images,($blowup_user['top_image'] ? $blowup_user['top_image'] : 'default')).'</p>'.
Index: plugins/buildtools/class.dc.maintenance.buildtools.php
===================================================================
--- plugins/buildtools/class.dc.maintenance.buildtools.php	(revision 2355)
+++ plugins/buildtools/class.dc.maintenance.buildtools.php	(revision 2286)
@@ -55,11 +55,9 @@
 			$main .= $this->fake_l10n($v['label']);
 		}
-		$ws = $this->core->auth->user_prefs->favorites;	// Favs old school !
-		if ($ws) {
-			$main .= "\n# Favorites \n\n";
-			foreach ($ws->dumpPrefs() as $k => $v) {
-				$fav = unserialize($v['value']);
-				$main .= $this->fake_l10n($fav['title']);
-			}
+		$ws = $this->core->auth->user_prefs->favorites;
+		$main .= "\n# Favorites \n\n";
+		foreach ($ws->dumpPrefs() as $k => $v) {
+			$fav = unserialize($v['value']);
+			$main .= $this->fake_l10n($fav['title']);
 		}
 		file_put_contents(dirname($__autoload['dcCore']).'/_fake_l10n.php', $main);
